---
title: XRWebGLLayerInit.stencil
slug: Web/API/XRWebGLLayerInit/stencil
tags:
  - API
  - AR
  - Property
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRWebGLLayerInit
  - augmented
  - stencil
---
<p>{{APIRef("WebXR Device API")}}{{securecontext_header}}</p>

<p><span class="seoSummary">When using the {{domxref("XRWebGLLayer.XRWebGLLayer", "XRWebGLLayer()")}} constructor to create a new WebGL rendering layer for WebXR, providing as the <code>layerInit</code> parameter an object whose <code><strong>stencil</strong></code> property is <code>false</code> requests that the new layer be created without a stencil buffer.</span></p>

<p>The <strong>stencil buffer</strong> is an optional buffer which, just like the depth buffer, contains one entry for every pixel in the frame buffer. Also just like the depth buffer, the value of an enter in the stencil buffer directly affects how (or if) the corresponding pixel is drawn during rendering. You can store values into each entry in the stencil bufer, then specify an operation that determines which stencil buffer values correspond to pixels which should be drawn to the screen during each frame.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">let layerInit = {
  stencil: false
};
let glLayer = new XRWebGLLayer(xrSession, gl, layerInit);

let glLayer = new XRWebGLLayer(xrSession, gl, { stencil: false });
</pre>

<h3 id="Value">Value</h3>

<p>A Boolean which can be set to <code>false</code> to specify that the new WebGL layer should not include a stencil buffer. The default value is <code>true</code>.</p>

<h2 id="Example">Example</h2>

<p>In this example, a new {{domxref("XRWebGLLayer")}} is created for a WebXR session, <code>xrSession</code>, without a stencil buffer.</p>

<pre class="brush: js">xrSession.updateRenderState({
  baseLayer: new XRWebGLLayer(xrSession, gl, {
     stencil: false
  });
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrwebgllayerinit-stencil','XRWebGLLayerInit.stencil')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRWebGLLayerInit.stencil")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebGL_API/Tutorial/Getting_started_with_WebGL">Getting started with WebGL</a></li>
 <li>WebGL stenciling methods include: <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/stencilOp">stencilOp()</a></code>, <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/clearStencil">clearStencil()</a></code>, <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/stencilFunc">stencilFunc()</a></code>, <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/stencilMask">stencilMask()</a></code>, <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/stencilMaskSeparate">stencilMaskSeparate()</a></code>, <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/stencilFuncSeparate">stencilFuncSeparate()</a></code>, <code><a href="/en-US/docs/Web/API/WebGLRenderingContext/stencilOpSeparate">stencilOpSeparate()</a></code>,</li>
</ul>
